          ;*************************************
          ;   SOFTWARE FOR ET-8032  VER 2.0    *
          ;        PROGRAM TEST ADC0804        *
          ;           FREE RUN MODE            *
          ;   DIGITAL INPUT OF ET-ADIO BOARD   *
          ;*************************************

            ORG    8000H
IC_ADC      EQU    0E04AH         ; port input of ADC0804
D_DSP       EQU    0E001H         ; port control LED flag
P_DSP       EQU    0E002H         ; port enable LED flag
FLAG        EQU    06H            ; data to enable LED flag
DSP         EQU    9F00H          ; display buffer (7 segment)
BUF         EQU    9F07H          ; display buffer (BCD)


            ;*******************
            ;   MAIN PROGRAM   *
            ;*******************

IN_ADC:     MOV    DPTR,#IC_ADC   ; point to input port
            MOVX   A,@DPTR        ; read input (from ADC0804)
            MOV    R0,A           ; save input
            LCALL  DSP_FLAG       ; display input to LED flag
            LCALL  DSP_SEG        ; display input to 7 segment
DELAY:      MOV    R6,#0FH        ; delay time
DELAY1:     DJNZ   R6,DELAY1
            AJMP   IN_ADC         ; loop for read input continue


            ;*********************************
            ;     SUB.  DISPLAY LED FLAG     *
            ;*********************************

DSP_FLAG:   MOV    DPTR,#P_DSP    ; set flag active
            MOV    A,#FLAG
            MOVX   @DPTR,A        ; enable flag
            MOV    DPTR,#D_DSP
            MOV    A,R0           ; get input
            MOVX   @DPTR,A        ; out data to flag
            RET


            ;*********************************
            ;     SUB. DISPLAY  7 SEGMENT    *
            ;*********************************

DSP_SEG:    MOV    DPTR,#BUF+2
            MOV    A,R0           ; get input
            MOVX   @DPTR,A        ; store BUF+2
            MOV    R2,A           ; store input HEX_BCDS
            MOV    R3,#00H
            MOV    A,#14H         ; call HEX_BCDS
            LCALL  0030H          ; HEX -> DEC
            MOV    DPTR,#BUF+1    ; store input UNPACK
            MOV    A,R3
            MOVX   @DPTR,A
            MOV    DPTR,#BUF+0
            MOV    A,R2
            MOVX   @DPTR,A
            MOV    A,#32H         ; call "UNPACK"
            LCALL  0030H          ; BUF -> DSP
            MOV    DPTR,#DSP+1    ; shift digit to left
            MOVX   A,@DPTR
            MOV    DPTR,#DSP+0
            MOVX   @DPTR,A
            MOV    DPTR,#DSP+2
            MOVX   A,@DPTR
            MOV    DPTR,#DSP+1
            MOVX   @DPTR,A
            MOV    DPTR,#DSP+3
            MOVX   A,@DPTR
            MOV    DPTR,#DSP+2
            MOVX   @DPTR,A
            MOV    DPTR,#DSP+3
            MOV    A,#00H
            MOVX   @DPTR,A
            MOV    A,#0AH         ; call "DISPLAY"
            LCALL  0030H
            RET

            END