          ;************************************
          ;   SOFTWARE FOR ET-BOARD VER 3.5   *
          ;       PROGRAM TEST ADC0804        *
          ;          INTERRUPT MODE           *
          ;   ANALOG INPUT OF ET-ADIO BOARD   *
          ;************************************

          CPU "Z80.TBL"
          HOF  "INT8"

          ORG 2000H
ADR_INT:  EQU 3FD6H         ; buffer for interrupt 0038H
IC_ADC:   EQU 8AH           ; ADC port control
BUF:      EQU 3FEFH         ; display buffer (BCD)
DSP:      EQU 3FE7H         ; display buffer (7 segment)
HBUF:     EQU 3FF2H         ; buffer (HEX) of HTOD,DTOH
DBUF:     EQU 3FF4H         ; buffer (DEC) of HTOD,DTOH

          ;*********************
          ;    MAIN PROGRAM    *
          ;*********************

START:    LD HL,INT38      ; Address of interrupt
          LD (ADR_INT),HL  ; fill interrupt to RAM bufferr
          IM 1             ; interrupt mode 1 set
          EI               ; Enable interrupt
LOOP:     LD A,00H
          OUT (IC_ADC),A   ; Trig ADC interrupt Active
          LD B,01H         ; delay time
          CALL DELAY
          JR LOOP          ; loop to read ADC input

          ;***********************
          ;*  DISPLAY 7 SEGMENT  *
          ;***********************

DSP_SEG:  PUSH AF
          LD (BUF+2),A     ; store input to buffer
          LD (HBUF+0),A    ; store input "HTOD"
          LD A,00H
          LD (HBUF+1),A
          LD A,0AH         ; call "HTOD"
          RST 10H ;
          LD  A,(DBUF+0)   ; store input "UNPK"
          LD  (BUF+0),A
          LD  A,(DBUF+1)
          LD  (BUF+1),A
          LD  A,07H        ; call "UNPK"
          RST 10H
          LD A,(DSP+1)     ; shift digit to left
          LD (DSP+0),A
          LD A,(DSP+2)
          LD (DSP+1),A
          LD A,(DSP+3)
          LD (DSP+2),A
          LD A,00H
          LD (DSP+3),A
          LD A,04H        ; call "SCAN"
          LD B,0FH        ; delay time
          RST 10H

          POP AF
          RET


          ;***************
          ;*  DELAY SUB. *
          ;***************

DELAY:    LD C,0
DEL1:     DEC C
          JR NZ,DEL1
          DJNZ DELAY
          RET

          ;******************************
          ;   INTERRUPT OF SUBROUTINE   *
          ;  I/P = PIN 16 OF Z80 (INT)  *
          ;******************************

INT38:    PUSH AF           ; Save register
          PUSH BC
          DI                ; disable interrupt

          IN A,(IC_ADC)     ; Read data from ADC
          CALL DSP_SEG      ; display 7 segment

          POP BC            ; Restore register
          POP AF
          EI                ; Enable interrupt
          RETI              ; Return interrupt to main
          END
