          ;*************************************
          ;   SOFTWARE FOR ET-BOARD VER 4.0    *
          ;       PROGRAM TEST 74LS245         *
          ;   DIGITAL INPUT OF ET-ADIO BOARD   *
          ;*************************************

          CPU "Z80.TBL"
          HOF  "INT8"

          ORG 2000H
IP_SW:    EQU 8DH         ; port 74LS245
P_OUT:    EQU 8FH         ; port 74LS374
P_LED:    EQU 40H         ; port LED flag

IN_SW:    CALL DSPLCD     ; display LCD
          IN A,(IP_SW)    ; read input switch
          XOR 0FFH        ; invert logic
          LD (INHEX),A    ; save input
          OUT (P_LED),A   ; display LED flag
          OUT (P_OUT),A   ; display LED
          JR IN_SW        ; loop continue

DSPLCD:   LD HL,WORD       ; get word
          LD A,04H         ; display word
          RST 10H
          LD A,(INHEX)     ; input (HEX)
          LD D,A
          LD A,14H         ; call "LCDHEX"
          RST 10H          ; display input (HEX)
          LD A,12H         ; call "RIGHT_LCD"
          RST 10H
          LD D,28H         ; ASCII of "("
          LD A,0EH         ; display "("
          RST 10H

          LD A,(INHEX)
          LD B,08H         ; counter for RLC A
BCDROT:   RLC A            ; rotate bit to carry
          LD (INBIT),A     ; save bit
          LD A,00H
          ADC A,30H
          LD D,A
          LD A,0EH         ; call "WRLCD"
          RST 10H          ; write LCD with ASCII
          JR RLCD
SLCD:     LD D,08H         ; position of LCD line 2
          LD A,0DH         ; call "GOTO_ADDR"
          RST 10H          ; defind LCD
          JR GLCD
RLCD:     LD A,13H         ; call "RDCUR"
          RST 10H          ; read position cursor
          CP 08H
          JR C,GLCD        ; less than 8 jump
          JR Z,SLCD        ; match jump
GLCD:     LD A,(INBIT)     ; restore bit
          DJNZ BCDROT
          LD D,29H         ; ASCII of ")"
          LD A,0EH         ; display ")"
          RST 10H
          LD A,2EH         ; call "DMSEC"
          LD B,9FH         ; delay time
          RST 10H
          RET

WORD:     DFB "IN:",00H

INHEX:    DFS  2   ; INPUT (HEX)
INBIT:    DFS  2   ; INPUT (8 BIT)

          END

